function [x,ifallo]=sollowtri(a,b)
% [x,ifallo]=solvetrinf(a,b)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%OBJETIVO: resolucion de un sistema de ecuaciones lineales
%          con matriz de coeficientes triangular inferior
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%EN ENTRADA:
% a : matriz de coeficientes del sistema. No se usa la parte
%     de encima de la diagonal principal.
% b : vector COLUMNA de terminos independientes.
%
%EN SALIDA:
% x : solucion calculada si ifallo=0
% ifallo: indicador de la evolucion del proceso con los valores:
%    0 : proceso finalizado con exito
%    1 : Fin no satisfactorio. Proceso incompleto.
%
eps1=eps^0.75;
n=size(b,1);
ifallo=0;
x=[];
if abs(a(1,1))<eps1
    fprintf('\n MATRIZ COMPUTACIONALMENTE SINGULAR.\n');
    ifallo=1;
    return
end

x(1,1)=b(1)/a(1,1);
for i=2:n
    if abs(a(i,i))<eps1
       fprintf('\n MATRIZ COMPUTACIONALMENTE SINGULAR.\n');
       ifallo=1;
       return
    end
    x(i,1)=(b(i)-a(i,1:i-1)*x(1:i-1))/a(i,i);
end
