function [x,ifallo]=solupptri(a,b)
% [x,ifallo]=solvetrsup(a,b)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%OBJETIVO: resolucion de un sistema de ecuaciones lineales
%          con matriz de coeficientes triangular superior
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%EN ENTRADA:
% a : matriz de coeficientes del sistema. No se usa la parte
%     de abajo de la diagonal principal.
% b : vector COLUMNA de terminos independientes.
%
%EN SALIDA:
% x : solucion calculada si ifallo=0
% ifallo: indicador de la evolucion del proceso con los valores:
%
%    0 : proceso finalizado con exito
%    1 : Fin no satisfactorio. Proceso incompleto.
%
eps1=eps^0.75;
n=size(b,1);
ifallo=0;
x=[];
if abs(a(n,n))<eps1
    fprintf('\n MATRIZ COMPUTACIONALMENTE SINGULAR.\n');
    ifallo=1;
    return
end

x(n,1)=b(n)/a(n,n);
for i=n-1:-1:1
    if abs(a(i,i))<eps1
       fprintf('\n MATRIZ COMPUTACIONALMENTE SINGULAR.\n');
       ifallo=1;
       return
    end
    x(i,1)=(b(i)-a(i,i+1:n)*x(i+1:n))/a(i,i);
end
